<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 06/19/2004 *
 * ===================                          Last change: 06/19/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-admins_contct.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Contact an admin through mail or message         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Admin per Mail oder Nachricht kontaktieren       *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

if ((isFormSent()) && (isGetRequestParameterSet('admin'))) {
	// Send mail or message
	if ((isExtensionActive('msg')) && (postRequestParameter('type') == 'message')) {
		// Add message
		$message = loadEmailTemplate('admins_msg_contct_admin', postRequestParameter('text'), 0);
		sendAdminMessage(getRequestParameter('admin'), '{--ADMINS_MSG_FROM_ADMIN--}', $message);
	} else {
		// Load admin's email address
		$email = getAdminEmail(bigintval(getRequestParameter('admin')));

		// Load email template and send the mail to the admin
		$message = loadEmailTemplate('admins_mail_contct_admin', postRequestParameter('text'), 0);
		sendEmail($email, '{--ADMINS_MSG_FROM_ADMIN--}', $message);
	}

	// Mail / message dropped
	loadTemplate('admin_settings_saved', false, '{--ADMINS_ADMIN_CONTACTED--}');
} elseif (isGetRequestParameterSet('admin')) {
	// Load contact form template
	$content['admin'] = getRequestParameter('admin');

	if (isExtensionActive('msg')) {
		// Add option to select between mail and message
		$content['message_selection'] = loadTemplate('admin_admins_contct_select', true);
	} else {
		// Outout hidden input
		$content['message_selection'] = loadTemplate('admin_admins_contct_default', true);
	}

	// Load main form
	loadTemplate('admin_admins_contct_form', false, $content);
} else {
	// Please select an admin!
	loadTemplate('admin_settings_saved', false, '{--ADMINS_SELECT_ADMIN--}');
}

// [EOF]
?>
