<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 04/02/2005 *
 * ===================                          Last change: 05/19/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : sponsor.php                                      *
 * -------------------------------------------------------------------- *
 * Short description : Sponsor area                                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sponsorenbereich                                 *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software. You can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License.       *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif ((!isExtensionActive('sponsor'))) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('sponsor'));
	return;
} elseif (!isSponsor()) {
	// No sponsor!
	addFatalMessage(__FILE__, __LINE__, '{--SPONSOR_ONLY_AREA_ENTERED--}');
	return;
} elseif ((!isWhatSet()) || (getWhat() == '')) {
	// Empty what value detected!
	setWhat('welcome');
}

// A valid sponsor login and we are allowed to enter this module so let's
// update his cookies and online time
updateSponsorLogin();

// Generate menu
$content['menu'] = addSponsorMenu(getWhat());

// Generate right-side output
$content['content'] = addSponsorContent(getWhat());

// Load header template
$content['header'] = loadTemplate('sponsor_header', true);

// Load footer template
$content['footer'] = loadTemplate('sponsor_footer', true);

// 'You are here' navigation
$content['you_are_here'] = addYouAreHereLink('sponsor', getWhat(), true);

// Load main sponsor template
loadTemplate('sponsor_main', false, $content);

// [EOF]
?>
