<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 12/12/2008 *
 * ===================                          Last change: 12/12/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : pool-bonus.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Sends queued bonus mails from the pool           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sendet freigegebene Bonus-Mails aus dem Pool     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Don't run on daily reset
if ((isResetModeEnabled()) || (!isHtmlOutputMode())) {
	// Skip here
	return false;
} elseif (!isExtensionActive('bonus')) {
	// Abort if extension bonus is not active
	return false;
}

// Need this here
// Only send bonus mail when bonus extension is active and maximum send-mails is not reached
if ($GLOBALS['pool_cnt'] < getMaxSend()) {
	// Do we need to send out bonus mails?
	if (isExtensionActive('html_mail')) {
		//                                 0        1        2          3          4        5          6            7         8        9            10           11
		$result_bonus = SQL_QUERY("SELECT `id`, `subject`, `text`, `receivers`, `points`, `time`, `data_type`, `timestamp`, `url`, `cat_id`, `target_send`, `html_msg` FROM `{?_MYSQL_PREFIX?}_bonus` WHERE `data_type`='NEW' ORDER BY `timestamp` DESC", __FILE__, __LINE__);
	} else {
		//                                 0        1        2          3          4        5          6            7         8        9            10
		$result_bonus = SQL_QUERY("SELECT `id`, `subject`, `text`, `receivers`, `points`, `time`, `data_type`, `timestamp`, `url`, `cat_id`, `target_send` FROM `{?_MYSQL_PREFIX?}_bonus` WHERE `data_type`='NEW' ORDER BY `timestamp` DESC", __FILE__, __LINE__);
	}

	if (!SQL_HASZERONUMS($result_bonus)) {
		// Send these mails away...
		$count2 = '';
		while ($DATA = SQL_FETCHARRAY($result_bonus)) {
			// Message is active in queue
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_bonus` SET `data_type`='QUEUE' WHERE `id`=%s LIMIT 1",
				array(bigintval($DATA['id'])), __FILE__, __LINE__);

			// "Explode" all receivers into an array
			if (isInString(';', $DATA['receivers'])) {
				// There's more than one receiver in the list...
				$receivers = explode(';', $DATA['receivers']);
			} elseif (!empty($DATA['points'])) {
				// Only one user left
				$receivers = array($DATA['receivers']);
			} else {
				// No users left
				$receivers = array(0);
			}
			$dummy = $receivers;

			// Now, if we are good little boys and girls Santa Claus left us some user-ids.
			// We can now send mails to them...
			foreach ($receivers as $key => $userid) {
				// Load personal data
				if (fetchUserData($userid)) {
					// The final receiver does exists so we can continue...
					//* DEBUG: */ debugOutput('OK!/L:'.__LINE__);

					// Remove receiver from list
					$status = removeReceiver($dummy, $key, $userid, $DATA['id'], $DATA['id'], true);

					// Did it work?
					switch ($status) {
						case 'done': // Done!
							// Prepare the mail
							$mailText = loadEmailTemplate('bonus-mail', $DATA, $userid);

							// Send mail away
							if (isset($DATA['html_msg'])) {
								// Send HTML?
								sendEmail(getUserData('email'), $DATA['subject'], $mailText, $DATA['html_msg']);
							} else {
								// No HTML mail!
								sendEmail(getUserData('email'), $DATA['subject'], $mailText);
							}

							// Count one up and remove entry from dummy array
							$GLOBALS['pool_cnt']++; unset($dummy[$key]);

							if (isExtensionInstalledAndNewer('user', '0.1.4')) {
								// Update mails received for receiver
								SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `emails_received`=`emails_received`+1 WHERE `userid`=%s LIMIT 1",
								array(bigintval($userid)), __FILE__, __LINE__);
							} // END - if

							// Do we have send maximum mails?
							if (($GLOBALS['pool_cnt'] >= getMaxSend()) || (countSelection($dummy) == 0)) {
								// Yes, we have
								//* DEBUG: */ debugOutput('*EXIT/L:'.__LINE__);
								break;
							} // END - if
							break;

						default: // Unknown return type
							logDebugMessage(__FILE__, __LINE__, 'Unknown status ' . $status . ' detected. pool_id=' . $DATA['id'] . ',userid=' . $DATA['userid'] . ',stats_id=' . $stats_id);
							break;
					} // END - switch
				} // END - if
			} // END - foreach

			// Update mediadata if version is 0.0.4 or higher
			if (isExtensionInstalledAndNewer('mediadata', '0.0.4')) {
				// Update entry (or add missing
				$P = $GLOBALS['pool_cnt'];
				if (!empty($count2) && empty($GLOBALS['pool_cnt'])) $P = $count2;
				//* DEBUG: */ debugOutput('+MEDIA/L:'.__LINE__.'/'.$P.'+');
				updateMediadataEntry(array('total_send', 'bonus_send'), 'add', $P);
			} // END - if

			// Close sending system
			//* DEBUG: */ debugOutput('-L:'.__LINE__.'/'.countSelection($dummy).'-');
			if (countSelection($dummy) == 0) {
				// Queue reached!
				SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_bonus`
SET
	`data_type`='SEND',
	`target_send`=0,
	`receivers`=''
WHERE
	`id`=%s
LIMIT 1",
					array(bigintval($DATA['id'])), __FILE__, __LINE__);
				//* DEBUG: */ debugOutput('*L:'.__LINE__.'*');

				// Update mediadata if version is 0.0.4 or higher
				if (isExtensionInstalledAndNewer('mediadata', '0.0.4')) {
					// Update entry (or add missing)
					//* DEBUG: */ debugOutput('*MEDIA/L:'.__LINE__.'*');
					updateMediadataEntry(array('total_orders', 'bonus_orders'), 'add', 1);
				} // END - if
			} elseif ($GLOBALS['pool_cnt'] >= getMaxSend()) {
				// Update bonus pool
				SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_bonus`
SET
	`data_type`='NEW',
	`target_send`=%s,
	`receivers`='%s'
WHERE
	`id`=%s
LIMIT 1",
					array(
						countSelection($dummy),
						implode(';', $dummy),
						bigintval($DATA['id'])
					), __FILE__, __LINE__);
				//* DEBUG: */ debugOutput('*L:'.__LINE__.'<pre>'.print_r($dummy, true).'</pre>!!!');
				break;
			}
		} // END - while
	} // END - if

	// Free memory
	SQL_FREERESULT($result_bonus);

	// Remove variable
	unset($mailText);
} // END - if

// [EOF]
?>
